/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// OnContactStateUpdated - Invoked when a contact state has changed (presence or phone).
    /// </summary>
    [DataContract]
        public partial class ContactsSubscriptions :  IEquatable<ContactsSubscriptions>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ContactsSubscriptions" /> class.
        /// </summary>
        /// <param name="onContactStateUpdated">onContactStateUpdated.</param>
        public ContactsSubscriptions(string onContactStateUpdated = default(string))
        {
            this.OnContactStateUpdated = onContactStateUpdated;
        }
        
        /// <summary>
        /// Gets or Sets OnContactStateUpdated
        /// </summary>
        [DataMember(Name="onContactStateUpdated", EmitDefaultValue=false)]
        public string OnContactStateUpdated { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ContactsSubscriptions {\n");
            sb.Append("  OnContactStateUpdated: ").Append(OnContactStateUpdated).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ContactsSubscriptions);
        }

        /// <summary>
        /// Returns true if ContactsSubscriptions instances are equal
        /// </summary>
        /// <param name="input">Instance of ContactsSubscriptions to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ContactsSubscriptions input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.OnContactStateUpdated == input.OnContactStateUpdated ||
                    (this.OnContactStateUpdated != null &&
                    this.OnContactStateUpdated.Equals(input.OnContactStateUpdated))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.OnContactStateUpdated != null)
                    hashCode = hashCode * 59 + this.OnContactStateUpdated.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
